import java.io.IOException;
import java.net.SocketException;
import java.util.Random;

/**
 * Serverprogramm, das die Daten des Servers versendet. Diese Klasse darf nicht
 * veraendert werden.
 * 
 */
public final class DataProvider extends Thread {

	private final AServer server;
	private Random rnd;
	private int max;
	private final int amount;

	/**
	 * Konstruktor.
	 * 
	 * @param amount
	 *            Anzahl der maximal an jeden Client zu versendenden
	 *            Nachrichten.
	 * @throws IOException
	 */
	public DataProvider(int amount) throws IOException {
		server = new Server(2096);
		rnd = new Random();
		max = 250;
		
		this.amount = amount;
	}

	/**
	 * Generiert und sendet die Nachrichten an die Clients.
	 */
	@Override
	public void run() {
		int counter = 0;
                int i,j;
		while (counter < amount) {
			System.out.println("Sleeping");
			Util.sleep(1);
			System.out.println("Sending");
			for (int x = 0; x < server.connectionCount() ; x++) {
				if (server.isConnected(x)) {
					try {   i = rnd.nextInt(max);
					        System.out.println("  to client " + x + ": " + i);				
    						server.sendMessage(x, "" + i);
						Util.sleep(1);
                                                j = rnd.nextInt(max);						
                                                System.out.println("  to client " + x + ": " + j);
                                                server.sendMessage(x, "" + j);    

							int expected = j + i;

							System.out.println("Client " + x + ": "
									+ server.receiveMessage(x)
									+ " (expected : " + expected + " )");
						

					} catch (SocketException se) {
						server.disconnect(x);
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
			counter++;
		}
		System.out.println("Disconnecting");
		server.disconnect();
		System.out.println("Finished");
	}
}
